#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=Icon.ico
#AutoIt3Wrapper_Compression=4
#AutoIt3Wrapper_UseX64=n
#AutoIt3Wrapper_Res_Description=LastOS ChangeWallpaper Auto
#AutoIt3Wrapper_Res_Fileversion=17.7.3.1
#AutoIt3Wrapper_Res_LegalCopyright=LastOS
#AutoIt3Wrapper_Res_requestedExecutionLevel=asInvoker
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

;*********************************
;*********************************
;***    ChangeWallpaperAuto    ***
;*********************************
;*********************************

; This program is free software: you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation, either version 3 of the License, or
; (at your option) any later version.

; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.

; You should have received a copy of the GNU General Public License
; along with this program.  If not, see <http://www.gnu.org/licenses/>.

; Copyright (c)2017, Team LastOS
; http://www.LastOS.org

;****************************************************** Preperation *******************************************************
#include <String.au3>

RegDelete("HKCU\SOFTWARE\Microsoft\Windows\CurrentVersion\RunOnce", "ChangeWall")
FileDelete(@StartMenuDir & "\Programs\Startup\ChangeWallpaper.lnk")

$Ratio = @DesktopWidth/@DesktopHeight
$WallpaperFile="Wallpaper"
If $Ratio > 1.5 Then
	$WallpaperFile="Wallpaper-Wide"
EndIf
$ExtraRes=""
;MsgBox(0,"Here",String(@DesktopWidth))
If @DesktopWidth >=2559 Then
	;MsgBox(0,"Test",@WindowsDir & "\Web\Wallpaper\Windows\"&$WallpaperFile&"-2k.jpg")
	If FileExists(@WindowsDir & "\Web\Wallpaper\Windows\"&$WallpaperFile&"-2k.jpg") Then $ExtraRes = "-2k"
EndIf
If @DesktopWidth >=3839 Then
	If FileExists(@WindowsDir & "\Web\Wallpaper\Windows\"&$WallpaperFile&"-4k.jpg") Then $ExtraRes = "-4k"
EndIf
If @DesktopWidth >=7679 Then
	If FileExists(@WindowsDir & "\Web\Wallpaper\Windows\"&$WallpaperFile&"-8k.jpg") Then $ExtraRes = "-8k"
EndIf

ChangeDesktopWallpaper (@WindowsDir & "\Web\Wallpaper\Windows\"&$WallpaperFile&$ExtraRes&".jpg")

;msgbox (0,"Here",@WindowsDir & "\Web\Wallpaper\Windows\"&$WallpaperFile&$ExtraRes&".jpg")

exit

Func ChangeDesktopWallpaper($bmp)
;===============================================================================
; Usage: _ChangeDesktopWallPaper(@WindowsDir & '\' & 'sand.bmp')
; Parameter(s): $bmp - Full Path to BitMap File (*.bmp)
; Requirement(s): None.
; Return Value(s): On Success - Returns 0
; On Failure - -1
;===============================================================================

If Not FileExists($bmp) Then Return -1
;The $SPI* values could be defined elsewhere via #include - if you conflict,
; remove these, or add if Not IsDeclared "SPI_SETDESKWALLPAPER" Logic
Local $SPI_SETDESKWALLPAPER = 20
Local $SPIF_UPDATEINIFILE = 1
Local $SPIF_SENDCHANGE = 2
Local $REG_DESKTOP= "HKEY_CURRENT_USER\Control Panel\Desktop"

;Don't tile -  Stretch
RegWrite($REG_DESKTOP, "TileWallPaper", "REG_SZ", 0)
RegWrite($REG_DESKTOP, "WallpaperStyle", "REG_SZ", 2)
RegWrite($REG_DESKTOP, "Wallpaper", "REG_SZ", $bmp)

DllCall("user32.dll", "int", "SystemParametersInfo", _
"int", $SPI_SETDESKWALLPAPER, _
"int", 0, _
"str", $bmp, _
"int", BitOR($SPIF_UPDATEINIFILE, $SPIF_SENDCHANGE))

Return 0
EndFunc;==>_ChangeDestopWallpaper